%define build_qtnx 1
%define build_nxlaunch 0

Name:           freenx-client
Version:        0.9.0
Release:        2%{?dist}
Summary:        NX Client Library (nxcl).

Group:          Applications/Internet
License:        GPL
URL:            http://freenx.berlios.de

# Note: nxcl, qtnx, and nxlaunch are freenx packages, available from
# http://svn.berlios.de/svnroot/repos/freenx/
# They are part of the NX package as they also require several nx libraries to build
# Note: nxlaunch does not currently function and is turned off.  They only work in
# CentOS 5.

Source1:	nxcl-0.9.0.tar.gz
Source2:	qtnx-0.9.0.tar.gz
Source3:	nxlaunch-0.9.0.tar.gz
Source4:	COPYING
Source5:	qtnx.desktop
Source6:	qtnx-desktop.png

Patch0:		qtnx-build-in-nx.patch
Patch1:		nxcl-aconf-versions-centos5.patch
Patch2:		qtnx-convert-forms-43to42-centos5.patch
Patch3:		qtnx-multiple-id-key.patch
Patch4:		nxcl-chmod-600-keyid.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  expat-devel audiofile-devel openssl-devel libjpeg-devel libpng-devel libX11-devel libXp-devel imake libXdamage-devel libXrandr-devel libXtst-devel doxygen dbus-devel autoconf automake libtool nx-devel

%description
The FreeNX Client Library (nxcl) is used by FreeNX clients (qtnx and nxlaunch) to connect to a FreeNX server.

%prep
%setup -q -T -c %{name}-%{version} -a1 -a2 -a3
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1


%build
export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"

#I think I can remove this, do so if this builds
# perl -pi -e"s|CXXFLAGS=.-O.*|CXXFLAGS=\"$CXXFLAGS\"|" */configure

pushd nxcl
#build nxcl
  rm -rf missing
  rm -rf autom4te.cache
  rm -rf aclocal.m4 ltmain.sh
  aclocal
  autoheader
  autoconf
  libtoolize --copy --automake
  automake --add-missing --copy --gnu
  ./configure --prefix=/usr/lib/NX
   make
popd

%if %{build_qtnx}
  pushd qtnx
    #build qtnx
    export QTDIR="%{_libdir}/qt4" 
    export QTMAKE="%{_libdir}/qt4/bin/qmake"
    %{_libdir}/qt4/bin/qmake
    make
  popd
%endif

%if %{build_nxlaunch}
  pushd nxlaunch
    #build nxlaunch
    rm -rf missing
    rm -rf autom4te.cache
    rm -rf aclocal.m4 ltmain.sh
    aclocal
    autoheader
    autoconf
    libtoolize --copy --automake
    automake --add-missing --copy --gnu
    ./configure --prefix=%{_libdir}/NX
    make
  popd
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_bindir}
mkdir -p %{buildroot}/%{_libdir}/NX/lib
mkdir -p %{buildroot}/%{_libdir}/pkgconfig
mkdir -p %{buildroot}/%{_libdir}/NX/include/nxcl
mkdir -p %{buildroot}/%{_datadir}/pixmaps
mkdir -p %{buildroot}/%{_datadir}/applications

#install nxcl
mkdir -p %{buildroot}/%{_datadir}/doc/libnxcl-%{version}/
install -m 644 %{SOURCE4}   %{buildroot}/%{_datadir}/doc/libnxcl-%{version}

if [ ! -d %{buildroot}/%{_datadir}/doc/libnxcl-%{version}/nxcl/html ]; then
  mkdir -p %{buildroot}/%{_datadir}/doc/libnxcl-%{version}/nxcl/html
fi

install -m 644 nxcl/README %{buildroot}/%{_datadir}/doc/libnxcl-%{version}
cp -r nxcl/doc/html/* %{buildroot}/%{_datadir}/doc/libnxcl-%{version}/nxcl/html/

pushd nxcl
  cp -a nxcl/.libs/nxcl %{buildroot}/%{_libdir}/NX
  ln -snf nxagent %{buildroot}/%{_bindir}/nxcl
  cp -a test/.libs/libtest %{buildroot}/%{_libdir}/NX
  cp -a test/.libs/notQttest %{buildroot}/%{_libdir}/NX
  cp -a test/nxcmd  %{buildroot}/%{_libdir}/NX
  cp -a lib/.libs/libnxcl.a %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/libnxcl.la %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/.libs/libnxcl.so.1.0.0 %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/.libs/libnxcl.so %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/.libs/libnxcl.so.1 %{buildroot}/%{_libdir}/NX/lib
  cp -a nxcl.pc %{buildroot}/%{_libdir}/pkgconfig
  cp -a lib/*.h %{buildroot}/%{_libdir}/NX/include/nxcl/
  cp -a nxcl/nxcl.h %{buildroot}/%{_libdir}/NX/include/nxcl/
popd

%if %{build_qtnx}
mkdir -p %{buildroot}/%{_datadir}/doc/qtnx-%{version}/
install -m 644 %{SOURCE6} %{buildroot}/%{_datadir}/pixmaps
install -m 644 %{SOURCE5} %{buildroot}/%{_datadir}/applications
install -m 644 %{SOURCE4} %{buildroot}/%{_datadir}/doc/qtnx-%{version}
install -m 644 qtnx/README %{buildroot}/%{_datadir}/doc/qtnx-%{version}
pushd qtnx
  cp -a qtnx %{buildroot}/%{_libdir}/NX
  ln -snf nxagent %{buildroot}/%{_bindir}/qtnx
  chmod 755 %{buildroot}/%{_bindir}/qtnx
popd
%endif

%if %{build_nxlaunch}
mkdir -p %{buildroot}/%{_datadir}/doc/nxlaunch-%{version}/
install -m 644 %{SOURCE4}   %{buildroot}/%{_datadir}/doc/nxlaunch-%{version}
install -m 644 nxlaunch/README %{buildroot}/%{_datadir}/doc/nxlaunch-%{version}
pushd nxlaunch
  mkdir -p %{buildroot}/%{_libdir}/NX/share
  cp -a src/.libs/nxlaunch %{buildroot}/%{_libdir}/NX
  ln -snf nxagent %{buildroot}/%{_bindir}/nxlaunch
  cp -a src/nxconfig.glade %{buildroot}/%{_libdir}/NX/share
  cp -a src/nxlaunch.glade %{buildroot}/%{_libdir}/NX/share
  cp -a src/pixmaps/*.png %{buildroot}/%{_libdir}/NX/share
  cp -a lib/libcallbacks_nx.la %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/.libs/libcallbacks_nx.a %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/.libs/libcallbacks_nx.so.1.0.0 %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/.libs/libcallbacks_nx.so %{buildroot}/%{_libdir}/NX/lib
  cp -a lib/.libs/libcallbacks_nx.so.1 %{buildroot}/%{_libdir}/NX/lib
popd
%endif

%clean
rm -rf %{buildroot}

#### libnxcl ####
%package -n libnxcl
Summary: The FreeNX Client Library
Group: Applications/Internet
Requires: nx > 2.0.0, freenx > 0.7.0
Requires(post): policycoreutils
Requires(postun): policycoreutils

%description -n libnxcl
The FreeNX Client Library.

%post -n libnxcl
%{_sbindir}/semanage fcontext -f -- -a -t textrel_shlib_t '%{_libdir}/NX/lib/libnxcl.so.1.0.0' 2>/dev/null || :
%{_bindir}/chcon -t textrel_shlib_t %{_libdir}/NX/lib/libnxcl.so.1.0.0 2>/dev/null || :

%postun -n libnxcl
if [ $1 -eq 0 ]; then
  %{_sbindir}/semanage fcontext -f -- -d -t textrel_shlib_t '%{_libdir}/NX/lib/libnxcl.so.1.0.0' 2>/dev/null || :
fi

%files -n libnxcl
%defattr(-,root,root,-)
%doc %{_datadir}/doc/libnxcl-%{version}
%{_bindir}/*
%dir %{_libdir}/NX
%{_libdir}/NX/*
%exclude %dir %{_libdir}/NX/include
%exclude %{_libdir}/NX/include/*

%if %{build_nxlaunch}
%exclude %{_libdir}/NX/lib/libcallbacks*
%exclude %{_libdir}/NX/nxlaunch
%exclude %dir %{_libdir}/NX/share
%exclude %{_libdir}/NX/share/*
%exclude %{_bindir}/nxlaunch
%endif

%if %{build_qtnx}
%exclude %{_libdir}/NX/qtnx
%exclude %{_bindir}/qtnx
%endif
#end libnxcl

#### libnxcl-devel ####
%package -n libnxcl-devel
Summary: Development files for FreeNX Client Library
Group: Development/Libraries
Requires: libnxcl = %{version}-%{release}

%description -n libnxcl-devel
Development files for FreeNX Client Library.

%files -n libnxcl-devel
%defattr(-,root,root,-)
%dir %{_libdir}/NX/include
%{_libdir}/NX/include/*
%{_libdir}/pkgconfig/nxcl.pc
#end libnxcl-devel

#### qtnx ####

%if %{build_qtnx}
%package -n qtnx
Summary: QT4 based FreeNX Client
Group: Applications/Internet
Requires: libnxcl = %{version}-%{release}
BuildRequires: qt4-devel flex byacc

%description -n qtnx
A QT4 based FreeNX client linking to nxcl.

%files -n qtnx
%defattr(-,root,root,-)
%doc %{_datadir}/doc/qtnx-%{version}
%{_libdir}/NX/qtnx
%{_bindir}/qtnx
%{_datadir}/pixmaps/qtnx-desktop.png
%{_datadir}/applications/qtnx.desktop
%endif

#end qtnx

#### nxlaunch ####

%if %{build_nxlaunch}

%package -n nxlaunch
Summary: GTK+ based NX Client
Group: Applications/Internet
Requires: libnxcl = %{version}-%{release}
Buildrequires: glib2-devel gtk2-devel libglade2-devel libxml2-devel dbus-devel dbus-glib

%description -n nxlaunch
GTK+ based FreeNX Client linking to nxcl.

%post -n nxlaunch
%{_sbindir}/semanage fcontext -f -- -a -t textrel_shlib_t '%{_libdir}/NX/lib/libcallbacks_nx.so.1.0.0' 2>/dev/null || :
%{_bindir}/chcon -t textrel_shlib_t %{_libdir}/NX/lib/libcallbacks_nx.so.1.0.0  2>/dev/null || : 

%postun -n nxlaunch
if [ $1 -eq 0 ]; then
  %{_sbindir}/semanage fcontext -f -- -d -t textrel_shlib_t '%{_libdir}/NX/lib/libcallbacks_nx.so.1.0.0' 2>/dev/null || :
fi

%files -n nxlaunch
%defattr(-,root,root,-)
%doc %{_datadir}/doc/nxlaunch-%{version}
%{_libdir}/NX/lib/libcallbacks*
%{_libdir}/NX/nxlaunch
%dir %{_libdir}/NX/share/
%{_libdir}/NX/share/*
%{_bindir}/nxlaunch
%endif
#end nxlaunch

%changelog
* Sun Apr 13 2008 Johnny Hughes <johnny@centos.org> - 0.9.0-2
- added a logo and .desktop file to the Internet Menu.

* Sat Apr 12 2008 Johnny Hughes <johnny@centos.org> - 0.9.0-1 
- initial spec
